Ramp integration: operations for AI agents
Ramp connects to Type.com as an integration. This page lists the 277 operations documented for Claude and Codex in Type.com: 116 read, 114 write, 47 destructive.
About Ramp
Ramp is a platform that helps you manage your finances, track your income and expenses, and get insights into your business
Categories: Finance & Accounting
How to connect Ramp to Type.com
- Connect
- Managed OAuth through Pipedream when enabled for your workspace; OAuth client credentials
- Access
- Organization connection: one shared account for the workspace.
- MCP
- Selected payment-processing operations are not available through Type’s MCP server. Other operations remain available through MCP, subject to your connection’s permissions. These MCP restrictions do not apply within Type.
To add the connection, follow the steps in Space connections.
Documented operations
277 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.
277 operations listed.
Accounting
- Read
List general ledger accounts
GET /developer/v1/accounting/accounts
GET /developer/v1/accounting/accounts - Read
Fetch a general ledger account
GET /developer/v1/accounting/accounts/{gl_account_id}
GET /developer/v1/accounting/accounts/{gl_account_id} - Read
Fetch all accounting connections for the current business
GET /developer/v1/accounting/all-connections
GET /developer/v1/accounting/all-connections - Read
Fetch an accounting connection by ID
GET /developer/v1/accounting/connection/{connection_id}
GET /developer/v1/accounting/connection/{connection_id} - Read
List field option filter rules
Returns rules that define which options of a target field are available based on selected options of trigger fields. Filterable by targetfieldremoteid and targetfieldoptionremoteid.
GET /developer/v1/accounting/field-option-filter-rules - Read
List options for a given custom accounting field
GET /developer/v1/accounting/field-options
GET /developer/v1/accounting/field-options - Read
Fetch a custom accounting field option
GET /developer/v1/accounting/field-options/{field_option_id}
GET /developer/v1/accounting/field-options/{field_option_id} - Read
List custom accounting fields
GET /developer/v1/accounting/fields
GET /developer/v1/accounting/fields - Read
Fetch a custom accounting field
GET /developer/v1/accounting/fields/{field_id}
GET /developer/v1/accounting/fields/{field_id} - Read
Fetch inventory item accounting field
Returns the inventory item accounting field for the current accounting connection.
GET /developer/v1/accounting/inventory-item - Read
List inventory item options
GET /developer/v1/accounting/inventory-item/options
GET /developer/v1/accounting/inventory-item/options - Read
List Ramp-only accounting fields
GET /developer/v1/accounting/ramp-fields
GET /developer/v1/accounting/ramp-fields - Read
Fetch a Ramp-only accounting field
GET /developer/v1/accounting/ramp-fields/{field_id}
GET /developer/v1/accounting/ramp-fields/{field_id} - Read
Fetch tax code accounting field
Returns the tax code accounting field for the current accounting connection.
GET /developer/v1/accounting/tax/code - Read
List tax code options
GET /developer/v1/accounting/tax/code/options
GET /developer/v1/accounting/tax/code/options - Read
List tax rates
GET /developer/v1/accounting/tax/rates
GET /developer/v1/accounting/tax/rates - Read
List vendors
GET /developer/v1/accounting/vendors
GET /developer/v1/accounting/vendors - Read
Fetch a vendor
GET /developer/v1/accounting/vendors/{vendor_id}
GET /developer/v1/accounting/vendors/{vendor_id} - Read
Fetch the current active accounting connection (deprecated)
Fetch the currently active accounting connection. Deprecated by Ramp; use the all-connections endpoint instead.
GET /developer/v1/accounting/connection - Write
Upload general ledger accounts
You can upload up to 500 general ledger accounts in an all-or-nothing fashion. If a general ledger accounts within a batch is malformed or violates a database constraint, the entire batch containing that account will be disregarded.
POST /developer/v1/accounting/accounts - Write
Update a general ledger account
This endpoint can be used to update the name or code of a GL account;
PATCH /developer/v1/accounting/accounts/{gl_account_id} - Write
Post accounting coding selections to an object
POST /developer/v1/accounting/codings
POST /developer/v1/accounting/codings - Write
Register a new API based accounting connection
A connection is required in order to use our accounting API functionality. If a Universal CSV connection already exists, it will be upgraded to an API based connection.
POST /developer/v1/accounting/connection - Write
Update an accounting connection
This endpoint is restricted to Accounting API based connections.
PATCH /developer/v1/accounting/connection/{connection_id} - Write
Reactivate a previously unlinked accounting connection
This endpoint allows reactivating a previously disconnected accounting connection by changing its status back to linked. This preserves all previous accounting field configurations and settings. The business must not have any other active accounting connections.
POST /developer/v1/accounting/connection/{connection_id}/reactivate - Write
Mark an inactive accounting API based connection as ready to migrate
There must be a different active accounting connection that the customer will migrate away from. Marking an inactive accounting API based connection as ready to migrate makes it available to the customer in the ERP migration flow UI.
POST /developer/v1/accounting/connection/{connection_id}/ready-to-migrate - Write
Upload entities
You can upload up to 500 entities in an all-or-nothing fashion. Entities with matching external IDs on this connection are updated and reactivated if inactive. Entities omitted from the upload are unchanged.
POST /developer/v1/accounting/entities - Write
Bulk create field option filter rules
Rules define which options of a target tracking category are available based on selected options of trigger tracking categories. Multiple rules for the same target option use OR logic between them. Multiple requiredselections within a single rule use AND logic.
POST /developer/v1/accounting/field-option-filter-rules - Write
Upload new options
You can upload up to 500 new field options for a given custom accounting field in an all-or-nothing fashion. If a field option within a batch is malformed or violates a database constraint, the entire batch containing that field option will be disregarded.
POST /developer/v1/accounting/field-options - Write
Update a custom accounting field option
PATCH /developer/v1/accounting/field-options/{field_option_id}
PATCH /developer/v1/accounting/field-options/{field_option_id} - Write
Create a new custom accounting field
If a custom field with the same id already exists on Ramp, then that existing one will be returned instead of creating a new one; If the existing custom field is inactive, it will be reactivated.
POST /developer/v1/accounting/fields - Write
Update a custom accounting field
PATCH /developer/v1/accounting/fields/{field_id}
PATCH /developer/v1/accounting/fields/{field_id} - Write
Create a new inventory item accounting field
There can only be one active inventory item accounting field per accounting connection.
POST /developer/v1/accounting/inventory-item - Write
Update inventory item accounting field
PATCH /developer/v1/accounting/inventory-item
PATCH /developer/v1/accounting/inventory-item - Write
Upload inventory item options
There must be an active inventory item accounting field for the accounting connection.
POST /developer/v1/accounting/inventory-item/options - Write
Update an inventory item option
PATCH /developer/v1/accounting/inventory-item/options/{option_id}
PATCH /developer/v1/accounting/inventory-item/options/{option_id} - Write
Upload new options for a Ramp-only field
POST /developer/v1/accounting/ramp-field-options
POST /developer/v1/accounting/ramp-field-options - Write
Update a Ramp-only field option
PATCH /developer/v1/accounting/ramp-field-options/{field_option_id}
PATCH /developer/v1/accounting/ramp-field-options/{field_option_id} - Write
Create a Ramp-only accounting field
POST /developer/v1/accounting/ramp-fields
POST /developer/v1/accounting/ramp-fields - Write
Update a Ramp-only accounting field
PATCH /developer/v1/accounting/ramp-fields/{field_id}
PATCH /developer/v1/accounting/ramp-fields/{field_id} - Write
Mark objects as ready to sync to your accounting provider
Marking an object (for example a transaction) as ready to sync flags it as reviewed and complete, so it will be included in the next accounting sync that exports data from Ramp to your connected accounting provider (ERP), such as NetSuite, QuickBooks, Xero, or Sage Intacct.
POST /developer/v1/accounting/ready-to-sync - Write
Post sync status
This endpoint allows customers to notify Ramp of a list of sync results. An idempotency key is required to ensure that subsequent requests are properly handled.
POST /developer/v1/accounting/syncs - Write
Create a new tax code accounting field
There can only be one active tax code accounting field per accounting connection.
POST /developer/v1/accounting/tax/code - Write
Update tax code accounting field
PATCH /developer/v1/accounting/tax/code
PATCH /developer/v1/accounting/tax/code - Write
Upload tax code options
There must be an active tax code accounting field for the accounting connection.
POST /developer/v1/accounting/tax/code/options - Write
Update a tax code option
PATCH /developer/v1/accounting/tax/code/options/{option_id}
PATCH /developer/v1/accounting/tax/code/options/{option_id} - Write
Upload tax rates
You can upload up to 500 tax rates in an all-or-nothing fashion. If a tax rate within a batch is malformed or violates a database constraint, the entire batch will be disregarded.
POST /developer/v1/accounting/tax/rates - Write
Update a tax rate
PATCH /developer/v1/accounting/tax/rates/{tax_rate_id}
PATCH /developer/v1/accounting/tax/rates/{tax_rate_id} - Write
Upload vendors
You can upload up to 500 vendors in an all-or-nothing fashion. If a vendors within a batch is malformed or violates a database constraint, the entire batch containing that vendors will be disregarded.
POST /developer/v1/accounting/vendors - Write
Update a vendor
PATCH /developer/v1/accounting/vendors/{vendor_id}
PATCH /developer/v1/accounting/vendors/{vendor_id} - Destructive
Delete a general ledger account
DELETE /developer/v1/accounting/accounts/{gl_account_id}
DELETE /developer/v1/accounting/accounts/{gl_account_id} - Destructive
Disconnect an accounting connection
This endpoint only allows disconnecting API based connections.
DELETE /developer/v1/accounting/connection - Destructive
Bulk delete field option filter rules
Removes specific rules identified by their target option and required selections. Rules that don't exist are counted as duplicates (no-op).
DELETE /developer/v1/accounting/field-option-filter-rules - Destructive
Update a custom accounting field option
PUT /developer/v1/accounting/field-options/{field_option_id}
PUT /developer/v1/accounting/field-options/{field_option_id} - Destructive
Delete a custom accounting field option
DELETE /developer/v1/accounting/field-options/{field_option_id}
DELETE /developer/v1/accounting/field-options/{field_option_id} - Destructive
Delete a custom accounting field
DELETE /developer/v1/accounting/fields/{field_id}
DELETE /developer/v1/accounting/fields/{field_id} - Destructive
Delete inventory item accounting field
DELETE /developer/v1/accounting/inventory-item
DELETE /developer/v1/accounting/inventory-item - Destructive
Delete an inventory item option
DELETE /developer/v1/accounting/inventory-item/options/{option_id}
DELETE /developer/v1/accounting/inventory-item/options/{option_id} - Destructive
Delete a Ramp-only field option
DELETE /developer/v1/accounting/ramp-field-options/{field_option_id}
DELETE /developer/v1/accounting/ramp-field-options/{field_option_id} - Destructive
Delete a Ramp-only accounting field
DELETE /developer/v1/accounting/ramp-fields/{field_id}
DELETE /developer/v1/accounting/ramp-fields/{field_id} - Destructive
Delete tax code accounting field
DELETE /developer/v1/accounting/tax/code
DELETE /developer/v1/accounting/tax/code - Destructive
Delete a tax code option
DELETE /developer/v1/accounting/tax/code/options/{option_id}
DELETE /developer/v1/accounting/tax/code/options/{option_id} - Destructive
Delete a tax rate
DELETE /developer/v1/accounting/tax/rates/{tax_rate_id}
DELETE /developer/v1/accounting/tax/rates/{tax_rate_id} - Destructive
Delete a vendor
DELETE /developer/v1/accounting/vendors/{vendor_id}
DELETE /developer/v1/accounting/vendors/{vendor_id}
AI Spend
- Read
List provider API keys and their estimated spend
Results are sorted by estimated cost in descending order, then by API key ID in ascending order. A request can match at most 10,000 API keys. Use the providers or statuses filter to narrow larger result sets. Estimated cost is calculated for the requested period.
GET /developer/v1/ai-spend/api-keys - Read
Retrieve the business's AI spend settings
GET /developer/v1/ai-spend/settings
GET /developer/v1/ai-spend/settings - Read
Retrieve the business's Ramp Router semantic tagging settings
These settings define the taxonomies Ramp Router uses to label requests by what the work was for, and which API keys or users to exclude. Returns version 0 and an empty configuration until the settings are first saved, and 404 when the business does not use Ramp Router.
GET /developer/v1/ai-spend/tagging-settings - Read
List Ramp users with estimated AI spend during the requested period
User profile fields reflect current Ramp user metadata, independent of the requested dates. Only users with positive estimated spend are returned.
GET /developer/v1/ai-spend/team - Read
List AI usage and estimated spend grouped by the requested dimensions
Rows match the AI Spend page in Ramp. Each row covers one UTC day. By default rows are grouped by provider, model, and product; use groupby to choose other dimensions. Rows are sorted by usagedate, then by the grouped dimensions. A request can match at most 10,000 rows.
GET /developer/v1/ai-spend/usage - Destructive
Replace the business's AI spend settings
PUT /developer/v1/ai-spend/settings
PUT /developer/v1/ai-spend/settings - Destructive
Reset the business's AI spend settings to defaults
DELETE /developer/v1/ai-spend/settings
DELETE /developer/v1/ai-spend/settings - Destructive
Replace the business's Ramp Router semantic tagging settings
The configuration replaces the current one. Send the version from your last read as expectedversion; if the settings changed since, the request fails with 409 and you should read them again before retrying. Saving an unchanged configuration does not change the version.
PUT /developer/v1/ai-spend/tagging-settings
Application
- Read
Fetch a financing application
Since each business can only have one active financing application, this endpoint will only ever return a single application.
GET /developer/v1/applications - Write
Create a financing application
This endpoint will create a new business for the applicant and email them with instructions to sign up and continue the application. If the applicant email already exists in Ramp, an invitation email will be re-sent if the business is still in the application stage.
POST /developer/v1/applications
Approvals
- Read
List approval data for a set of Transactions, Reimbursements, or Bills
GET /developer/v1/approvals
GET /developer/v1/approvals - Write
Add an approver to an approval instance
This endpoint allows you to add a new approval step to an existing approval instance. The step can contain one or more users identified by either their UUID or email address. The step will be added at the specified position in the approval chain.
POST /developer/v1/approvals/{entity_type}/{entity_id}/add-step
Audit Log
- Read
Get audit log events
GET /developer/v1/audit-logs/events
GET /developer/v1/audit-logs/events
Bank Accounts
- Read
List bank accounts
GET /developer/v1/bank-accounts
GET /developer/v1/bank-accounts - Read
Get bank account details
GET /developer/v1/bank-accounts/{bank_account_id}
GET /developer/v1/bank-accounts/{bank_account_id}
Banking
- Read
List banking accounts
Returns all banking accounts for the business, including checking accounts, brokerage accounts, and investment accounts. Each account includes its unique identifier, account type, and display name.
GET /developer/v1/banking/accounts - Read
Get balance history for a banking account
Returns daily available balance snapshots for the specified banking account. Use the startdate and enddate query parameters to filter results to a specific date range (ISO 8601 format).
GET /developer/v1/banking/accounts/{account_id}/balance-history - Read
List syncable banking transactions
Returns banking transactions that are available for syncing to an accounting provider. Requires an active accounting provider connection. Use query parameters to filter by date range, entity, or sync status.
GET /developer/v1/banking/syncable-transactions
Bill
- Read
List bills
GET /developer/v1/bills
GET /developer/v1/bills - Read
List draft bills
GET /developer/v1/bills/drafts
GET /developer/v1/bills/drafts - Read
Fetch a draft bill
GET /developer/v1/bills/drafts/{draft_bill_id}
GET /developer/v1/bills/drafts/{draft_bill_id} - Read
Fetch a bill
GET /developer/v1/bills/{bill_id}
GET /developer/v1/bills/{bill_id} - Read
Fetch a bill remittance receipt
GET /developer/v1/bills/{bill_id}/remittance-receipt
GET /developer/v1/bills/{bill_id}/remittance-receipt - Write
Create a bill
Batch payments cannot be created in the API.
POST /developer/v1/bills - Write
Create a draft bill
POST /developer/v1/bills/drafts
POST /developer/v1/bills/drafts - Write
Update a draft bill
PATCH /developer/v1/bills/drafts/{draft_bill_id}
PATCH /developer/v1/bills/drafts/{draft_bill_id} - Write
Upload a file attachment to an existing draft bill
Upload a file as an attachment to a draft bill. INVOICE type attachments cannot be uploaded if one already exists on the draft bill. This endpoint accepts the multipart/form-data format. Include the file as a part named 'file' with Content-Disposition: attachment.
POST /developer/v1/bills/drafts/{draft_bill_id}/attachments - Write
Submit a draft bill
POST /developer/v1/bills/drafts/{draft_bill_id}/submit
POST /developer/v1/bills/drafts/{draft_bill_id}/submit - Write
Update a bill
Only approved bills can be updated.
PATCH /developer/v1/bills/{bill_id} - Write
Associate Bills
Creates or updates the association between this bill and another bill in the same business. label is shown on this bill for the other bill and reverselabel on the other bill for this one; repeating the call replaces both labels.
POST /developer/v1/bills/{bill_id}/associations - Write
Upload a file attachment to an existing bill
Upload a file as an attachment to a bill. INVOICE type attachments cannot be uploaded if one already exists on the bill. This endpoint accepts the multipart/form-data format. Include the file as a part named 'file' with Content-Disposition: attachment.
POST /developer/v1/bills/{bill_id}/attachments - Write
Hold Bill
Blocks all payments rails on a bill and deschedules payments.
POST /developer/v1/bills/{bill_id}/hold - Write
Release Bill Hold
Allows payments to be scheduled on a bill.
POST /developer/v1/bills/{bill_id}/release - Destructive
Archive a bill
This is a destructive action. Associated inflight payments will be cancelled if possible or any attached one-time-card will be terminated. Paid bills and bills belonging to a batch payment cannot be deleted.
DELETE /developer/v1/bills/{bill_id} - Destructive
Remove Bill Association
Removes the association between the two bills in both directions.
DELETE /developer/v1/bills/{bill_id}/associations/{associated_bill_id}
Blank Canvas
- Write
Upload a document for a blank canvas workflow step
This endpoint accepts the multipart/form-data format. Include the document as a part with Content-Disposition: attachment. Include metadata as parts with Content-Disposition: form-data.
POST /developer/v1/blank-canvas-approvals/documents - Write
Approve or reject a blank canvas workflow step
POST /developer/v1/blank-canvas-approvals/{approval_trigger_instance_id}
POST /developer/v1/blank-canvas-approvals/{approval_trigger_instance_id} - Write
Update metadata for a blank canvas external approval request
PATCH /developer/v1/blank-canvas-approvals/{approval_trigger_instance_id}/metadata
PATCH /developer/v1/blank-canvas-approvals/{approval_trigger_instance_id}/metadata
Business
- Read
Fetch the company information
GET /developer/v1/business
GET /developer/v1/business - Read
Fetch the company balance information
GET /developer/v1/business/balance
GET /developer/v1/business/balance
Physical Card
- Read
List physical cards
Returns a paginated list of physical cards for the business. Cards can be filtered by user, activation status, termination status, and display name.
GET /developer/v1/cards/physical - Read
Fetch a physical card
GET /developer/v1/cards/physical/{card_id}
GET /developer/v1/cards/physical/{card_id} - Write
Create a physical card
POST /developer/v1/cards/physical
POST /developer/v1/cards/physical - Write
Update a physical card
PATCH /developer/v1/cards/physical/{card_id}
PATCH /developer/v1/cards/physical/{card_id} - Write
Suspend a card
The suspension is revertable.
POST /developer/v1/cards/physical/{card_id}/suspension - Destructive
Terminate a card
Please note that this action is irreversible.
DELETE /developer/v1/cards/physical/{card_id} - Destructive
Unsuspend a card
DELETE /developer/v1/cards/physical/{card_id}/suspension
DELETE /developer/v1/cards/physical/{card_id}/suspension
Card Vault Alias
- Read
Fetch a card's sensitive details
Accepts a card's ID and returns its sensitive details. Vault API access is required to use this endpoint.
GET /developer/v1/cards/vault/{card_id} - Write
Create a spend limit and retrieve sensitive card details
Vault API access is required to use this endpoint.
POST /developer/v1/cards/vault
Virtual Cards
- Read
List virtual cards
GET /developer/v1/cards/virtual
GET /developer/v1/cards/virtual - Read
Fetch a virtual card
GET /developer/v1/cards/virtual/{card_id}
GET /developer/v1/cards/virtual/{card_id}
Cashback
- Read
List cashback payments
GET /developer/v1/cashbacks
GET /developer/v1/cashbacks - Read
Fetch a cashback payment
GET /developer/v1/cashbacks/{cashback_id}
GET /developer/v1/cashbacks/{cashback_id}
Comments
- Read
List comments on an object's discussion thread
Requires {resourcename}:read scope and may require additional access. See objecttype description for more information.
GET /developer/v1/comments/{object_type}/{object_id} - Write
Create a comment on an object's discussion thread
Requires {resourcename}:write scope and may require additional access. See objecttype description for more information.
POST /developer/v1/comments/{object_type}/{object_id}
Custom Form
- Read
Fetch a custom form collection response by ID
GET /developer/v1/custom-form/collections/responses/{custom_form_collection_response_id}
GET /developer/v1/custom-form/collections/responses/{custom_form_collection_response_id}
Custom Records
- Read
List Custom Tables
GET /developer/v1/custom-records/custom-tables
GET /developer/v1/custom-records/custom-tables - Read
List Custom Table columns
GET /developer/v1/custom-records/custom-tables/{custom_table_name}/columns
GET /developer/v1/custom-records/custom-tables/{custom_table_name}/columns - Read
List Custom Table rows
GET /developer/v1/custom-records/custom-tables/{custom_table_name}/rows
GET /developer/v1/custom-records/custom-tables/{custom_table_name}/rows - Read
List all Matrix tables for the business
GET /developer/v1/custom-records/matrix-tables
GET /developer/v1/custom-records/matrix-tables - Read
List Matrix table rows
Returns rows with inputs and results separated. Inputs are always complete (all input columns), results are sparse (only set values).
POST /developer/v1/custom-records/matrix-tables/{table_name}/list-rows - Read
List Native Ramp tables
GET /developer/v1/custom-records/native-tables
GET /developer/v1/custom-records/native-tables - Read
List Custom Columns for a Native Ramp table
GET /developer/v1/custom-records/native-tables/{native_table_name}/columns
GET /developer/v1/custom-records/native-tables/{native_table_name}/columns - Read
List Custom Column values for rows of a Native Ramp table
GET /developer/v1/custom-records/native-tables/{native_table_name}/rows
GET /developer/v1/custom-records/native-tables/{native_table_name}/rows - Write
Create Custom Table
POST /developer/v1/custom-records/configure/custom-tables
POST /developer/v1/custom-records/configure/custom-tables - Write
Create Custom Table column
POST /developer/v1/custom-records/configure/custom-tables/{custom_table_name}/columns
POST /developer/v1/custom-records/configure/custom-tables/{custom_table_name}/columns - Write
Change the API name of a Custom Table's Column
PATCH /developer/v1/custom-records/configure/custom-tables/{custom_table_name}/columns/{column_name}
PATCH /developer/v1/custom-records/configure/custom-tables/{custom_table_name}/columns/{column_name} - Write
Extend Native Ramp table
POST /developer/v1/custom-records/configure/native-tables
POST /developer/v1/custom-records/configure/native-tables - Write
Create Native Ramp table field
POST /developer/v1/custom-records/configure/native-tables/{native_table_name}/columns
POST /developer/v1/custom-records/configure/native-tables/{native_table_name}/columns - Write
Change the API name of a Native Table's Custom Record Column
PATCH /developer/v1/custom-records/configure/native-tables/{native_table_name}/columns/{column_name}
PATCH /developer/v1/custom-records/configure/native-tables/{native_table_name}/columns/{column_name} - Write
Change the external key of a Custom Table row
PATCH /developer/v1/custom-records/custom-tables/{custom_table_name}/rows/{row_id}
PATCH /developer/v1/custom-records/custom-tables/{custom_table_name}/rows/{row_id} - Write
Append cells to a Custom Table
POST /developer/v1/custom-records/custom-tables/{table_name}/rows/-/append
POST /developer/v1/custom-records/custom-tables/{table_name}/rows/-/append - Write
Create a Matrix table
Matrix tables are special-purpose lookup tables where unique combinations of input values map to result values.
POST /developer/v1/custom-records/matrix-tables - Write
Add a result column to an existing Matrix table
Allows adding result columns to already-created matrix tables without modifying the input columns. Only result columns (users and accountingfieldoptions) can be added. Input columns cannot be added after table creation.
POST /developer/v1/custom-records/matrix-tables/{table_name}/columns - Write
Change the API name of a Matrix table column (input or result)
This changes the internal name used in API calls while preserving the human-readable label. Both input and result columns can be renamed.
PATCH /developer/v1/custom-records/matrix-tables/{table_name}/columns/{column_name} - Write
Change the API name of a Matrix table
POST /developer/v1/custom-records/matrix-tables/{table_name}/rename
POST /developer/v1/custom-records/matrix-tables/{table_name}/rename - Write
Append cells to Matrix table rows
Adds values to many-to-many result columns without replacing existing values. Only works on many-to-many result columns. Set ignoreduplicates=true to skip existing duplicate cells instead of erroring.
POST /developer/v1/custom-records/matrix-tables/{table_name}/rows/-/append - Write
Append cells to a Native Ramp table
POST /developer/v1/custom-records/native-tables/{native_table_name}/rows/-/append
POST /developer/v1/custom-records/native-tables/{native_table_name}/rows/-/append - Destructive
Set values for rows of a Custom Table
PUT /developer/v1/custom-records/custom-tables/{custom_table_name}/rows
PUT /developer/v1/custom-records/custom-tables/{custom_table_name}/rows - Destructive
Delete rows from a Custom Table
DELETE /developer/v1/custom-records/custom-tables/{custom_table_name}/rows
DELETE /developer/v1/custom-records/custom-tables/{custom_table_name}/rows - Destructive
Remove cells from a Custom Table
POST /developer/v1/custom-records/custom-tables/{table_name}/rows/-/remove
POST /developer/v1/custom-records/custom-tables/{table_name}/rows/-/remove - Destructive
Upsert Matrix table rows
Creates new rows or updates existing rows based on input values. Input values define row identity (via externalkey). Result values are mutable and can be partially updated.
PUT /developer/v1/custom-records/matrix-tables/{table_name}/rows - Destructive
Remove cells from Matrix table rows
Removes specific values from many-to-many result columns without affecting other values.
POST /developer/v1/custom-records/matrix-tables/{table_name}/rows/-/remove - Destructive
Delete a single Matrix table row by ID
Deletes the matrix row with the specified ID from the matrix table.
DELETE /developer/v1/custom-records/matrix-tables/{table_name}/rows/{row_id} - Destructive
Set values for rows of a Native Ramp table
PUT /developer/v1/custom-records/native-tables/{native_table_name}/rows
PUT /developer/v1/custom-records/native-tables/{native_table_name}/rows - Destructive
Remove cells from a Native Ramp table
POST /developer/v1/custom-records/native-tables/{native_table_name}/rows/-/remove
POST /developer/v1/custom-records/native-tables/{native_table_name}/rows/-/remove
Department
- Read
List departments
GET /developer/v1/departments
GET /developer/v1/departments - Read
Fetch a department
GET /developer/v1/departments/{department_id}
GET /developer/v1/departments/{department_id} - Write
Create a department
POST /developer/v1/departments
POST /developer/v1/departments - Write
Update a department
PATCH /developer/v1/departments/{department_id}
PATCH /developer/v1/departments/{department_id}
Embedded Cards
- Write
Create an embed init token for a card
The specified card must be activated and currently active
POST /developer/v1/embedded/cards/{card_id}/embed
Business Entities
- Read
List business entities
GET /developer/v1/entities
GET /developer/v1/entities - Read
Get a business entity
GET /developer/v1/entities/{entity_id}
GET /developer/v1/entities/{entity_id}
Fund
- Read
List funds
GET /developer/v1/funds
GET /developer/v1/funds - Read
Fetch a fund
GET /developer/v1/funds/{fund_id}
GET /developer/v1/funds/{fund_id} - Write
Create a fund
Fund may either be created with spendprogramid (inherits program defaults) or standalone (must provide displayname, spendingrestrictions, and permittedspendtypes).
POST /developer/v1/funds - Write
Update a fund
PATCH /developer/v1/funds/{fund_id}
PATCH /developer/v1/funds/{fund_id} - Write
Add members to a fund
POST /developer/v1/funds/{fund_id}/members
POST /developer/v1/funds/{fund_id}/members - Write
Suspend a fund member
POST /developer/v1/funds/{fund_id}/members/{user_id}/suspension
POST /developer/v1/funds/{fund_id}/members/{user_id}/suspension - Write
Suspend a fund
POST /developer/v1/funds/{fund_id}/suspension
POST /developer/v1/funds/{fund_id}/suspension - Destructive
Terminate a fund
DELETE /developer/v1/funds/{fund_id}
DELETE /developer/v1/funds/{fund_id} - Destructive
Remove members from a fund
DELETE /developer/v1/funds/{fund_id}/members
DELETE /developer/v1/funds/{fund_id}/members - Destructive
Unsuspend a fund member
DELETE /developer/v1/funds/{fund_id}/members/{user_id}/suspension
DELETE /developer/v1/funds/{fund_id}/members/{user_id}/suspension - Destructive
Unsuspend a fund
DELETE /developer/v1/funds/{fund_id}/suspension
DELETE /developer/v1/funds/{fund_id}/suspension
Item Receipts
- Read
List item receipts
GET /developer/v1/item-receipts
GET /developer/v1/item-receipts - Read
Fetch an item receipt
GET /developer/v1/item-receipts/{item_receipt_id}
GET /developer/v1/item-receipts/{item_receipt_id} - Write
Create an item receipt
POST /developer/v1/item-receipts
POST /developer/v1/item-receipts - Destructive
Delete an item receipt
DELETE /developer/v1/item-receipts/{item_receipt_id}
DELETE /developer/v1/item-receipts/{item_receipt_id}
Location
- Read
List locations
GET /developer/v1/locations
GET /developer/v1/locations - Read
Fetch a location
GET /developer/v1/locations/{location_id}
GET /developer/v1/locations/{location_id} - Write
Create a location
POST /developer/v1/locations
POST /developer/v1/locations - Write
Update a location
PATCH /developer/v1/locations/{location_id}
PATCH /developer/v1/locations/{location_id}
Memo
- Read
List memos
GET /developer/v1/memos
GET /developer/v1/memos - Read
Fetch a transaction memo
GET /developer/v1/memos/{transaction_id}
GET /developer/v1/memos/{transaction_id} - Write
Upload a new memo for a transaction
POST /developer/v1/memos/{transaction_id}
POST /developer/v1/memos/{transaction_id}
Merchant
- Read
List merchants
GET /developer/v1/merchants
GET /developer/v1/merchants
Purchase Order
- Read
List purchase orders
GET /developer/v1/purchase-orders
GET /developer/v1/purchase-orders - Read
Fetch a purchase order
GET /developer/v1/purchase-orders/{purchase_order_id}
GET /developer/v1/purchase-orders/{purchase_order_id} - Write
Create a purchase order
POST /developer/v1/purchase-orders
POST /developer/v1/purchase-orders - Write
Update a purchase order
Purchase order must be approved.
PATCH /developer/v1/purchase-orders/{purchase_order_id} - Write
Add line items to an existing purchase order
POST /developer/v1/purchase-orders/{purchase_order_id}/line-items
POST /developer/v1/purchase-orders/{purchase_order_id}/line-items - Write
Update a single line item on an existing purchase order
Purchase order must be approved.
PATCH /developer/v1/purchase-orders/{purchase_order_id}/line-items/{line_item_id} - Destructive
Archive a purchase order
POST /developer/v1/purchase-orders/{purchase_order_id}/archive
POST /developer/v1/purchase-orders/{purchase_order_id}/archive - Destructive
Delete a single line item from an existing purchase order
Purchase order must be approved.
DELETE /developer/v1/purchase-orders/{purchase_order_id}/line-items/{line_item_id}
Receipt Integrations
- Read
List emails opted out of receipt integrations
GET /developer/v1/receipt-integrations/opt-out
GET /developer/v1/receipt-integrations/opt-out - Write
Add a new email to receipt integrations opt-out list
POST /developer/v1/receipt-integrations/opt-out
POST /developer/v1/receipt-integrations/opt-out - Destructive
Remove an email from receipt integration opt-out list
Successful request will opt-in email to receipt integrations.
DELETE /developer/v1/receipt-integrations/opt-out/{mailbox_opted_out_email_uuid}
Receipt
- Read
List receipts
GET /developer/v1/receipts
GET /developer/v1/receipts - Read
Fetch a receipt
GET /developer/v1/receipts/{receipt_id}
GET /developer/v1/receipts/{receipt_id} - Write
Upload a receipt
image and optionally associate it with a transaction. If a transactionid is provided, the receipt will be linked directly to that transaction. If not, Ramp will attempt to automatically match the receipt to the most relevant transaction based on context.
POST /developer/v1/receipts
Reimbursement
- Read
List reimbursements
GET /developer/v1/reimbursements
GET /developer/v1/reimbursements - Read
Fetch a reimbursement
GET /developer/v1/reimbursements/{reimbursement_id}
GET /developer/v1/reimbursements/{reimbursement_id} - Write
Create a mileage reimbursement
POST /developer/v1/reimbursements/mileage
POST /developer/v1/reimbursements/mileage - Write
Upload a receipt for a reimbursement
If a reimbursementid is provided, the receipt will be linked directly to that reimbursement. If not, Ramp will attempt to automatically create a draft reimbursement via OCR. This endpoint accepts the multipart/form-data format.
POST /developer/v1/reimbursements/submit-receipt
Repayment
- Read
List repayments
This endpoint supports filtering. Results are sorted by creation date in descending order.
GET /developer/v1/repayments
Role
- Read
List custom roles
GET /developer/v1/roles
GET /developer/v1/roles
Spend Program
- Read
List spend programs
GET /developer/v1/spend-programs
GET /developer/v1/spend-programs - Read
Fetch a spend program
GET /developer/v1/spend-programs/{spend_program_id}
GET /developer/v1/spend-programs/{spend_program_id} - Read
List External Approval Request nodes for a spend program
GET /developer/v1/spend-programs/{spend_program_id}/workflow-nodes
GET /developer/v1/spend-programs/{spend_program_id}/workflow-nodes - Write
Create a spend program
POST /developer/v1/spend-programs
POST /developer/v1/spend-programs
Spend Request
- Write
Create a draft spend request via OCR
Requests should be made with multipart/form-data content type.
POST /developer/v1/spend-requests/draft-via-ocr
Statement
- Read
List statements
GET /developer/v1/statements
GET /developer/v1/statements - Read
Fetch a statement
GET /developer/v1/statements/{statement_id}
GET /developer/v1/statements/{statement_id}
Token
- Write
Create a token
Expects two headers: - Authorization header formed from base-64 encoded client credentials as Authorization: Basic - Content-Type: application/x-www-form-urlencoded Required content body depends on authorization type method, as defined by granttype.
POST /developer/v1/token - Destructive
Revoke an access or refresh token
Expects an authorization header formed from base-64 encoded client credentials as Authorization: Basic . Content body must be form-encoded.
POST /developer/v1/token/revoke
Transaction
- Read
List transactions
This endpoint supports filtering and ordering. If state is not set, all transactions except declined transactions will be returned. Note that setting multiple ordering parameters is unsupported.
GET /developer/v1/transactions - Read
Fetch a transaction
GET /developer/v1/transactions/{transaction_id}
GET /developer/v1/transactions/{transaction_id} - Write
Split a transaction into line items, or update an existing split
Send lineitems with amounts (in minor units) to create or replace the transaction's split; the line item amounts must sum to the transaction amount. Each line item can carry its own memo and accounting field selections.
PATCH /developer/v1/transactions/{transaction_id}
Transfer Payment
- Read
List transfer payments
For information on how to use this endpoint, refer to the Transfers Guide.
GET /developer/v1/transfers - Read
Fetch a transfer payment
For information on how to use this endpoint, refer to the Transfers Guide.
GET /developer/v1/transfers/{transfer_id}
Trips
- Read
List all trips for the business
GET /developer/v1/trips
GET /developer/v1/trips - Read
Fetch a trip
GET /developer/v1/trips/{trip_id}
GET /developer/v1/trips/{trip_id}
Unified Request
- Read
List unified requests with pagination
NOTE: - Response schema is not finalized and will have breaking changes prior to release - This endpoint is user aware, meaning perm-based filtering is applied to the query
GET /developer/v1/unified-requests - Read
Get a unified request
NOTE: - Response schema is not finalized and will have breaking changes prior to release - This endpoint is user aware, meaning perm-based filtering is applied to the query
GET /developer/v1/unified-requests/{unified_request_id} - Read
List attachments on a procurement request
Returns every non-deleted attachment on the request, oldest first. This includes supporting documents (SPENDREQUEST) and files appended to the purchase order PDF (PURCHASEORDER).
GET /developer/v1/unified-requests/{unified_request_id}/attachments - Write
Create a procurement request
Early access: enabled per business. Requires a business-scoped token. Purchase-order and approval-only procurement spend programs are supported; the request is created for requestownerid.
POST /developer/v1/unified-requests - Write
Edit a procurement request
Edits a native draft or submitted request as its owner. This action never submits a draft; edits to a submitted request go through normal approval reconciliation.
PATCH /developer/v1/unified-requests/{unified_request_id} - Write
Upload an attachment to a unified request
This endpoint accepts the multipart/form-data format. Include the file as a part named file with Content-Disposition: attachment.
POST /developer/v1/unified-requests/{unified_request_id}/attachments - Write
Submit a procurement draft request
Submits a procurement draft and returns its detail. An incomplete draft fails with error code DEVELOPER7195; additionalinfo.validationerrors and additionalinfo.fieldstoanswer list what is missing.
POST /developer/v1/unified-requests/{unified_request_id}/submit - Destructive
Delete a procurement request
Requires a business-scoped token and acts on behalf of the request owner. Shared procurement eligibility and request-owner permissions apply; approved and rejected requests can be eligible for deletion. A draft can only be deleted when its owner is also its creator.
DELETE /developer/v1/unified-requests/{unified_request_id}
User
- Read
List users
GET /developer/v1/users
GET /developer/v1/users - Read
Fetch deferred task status
GET /developer/v1/users/deferred/status/{task_id}
GET /developer/v1/users/deferred/status/{task_id} - Read
Fetch a user
GET /developer/v1/users/{user_id}
GET /developer/v1/users/{user_id} - Write
Create a user invite
Call this endpoint to trigger an async task to send out a user invite via email. Users will need to accept the invite in order to be onboarded. Assign a user to a specific entity by specifying a locationid on creation.
POST /developer/v1/users/deferred - Write
Update a user
PATCH /developer/v1/users/{user_id}
PATCH /developer/v1/users/{user_id} - Write
Deactivate a user
When users are deactivated, they will no longer be able to log in, spend on cards, or receive any notifications from Ramp.
PATCH /developer/v1/users/{user_id}/deactivate - Write
Manage a user's invite lifecycle
Performs one of three actions against a draft user, delegating to the Identity-owned invite / scheduled-invitation services: - SCHEDULE: Create or update a scheduled invitation at invitationtime. - DESCHEDULE: Cancel any pending scheduled invitation.
POST /developer/v1/users/{user_id}/invite - Write
Reactivate a user
Upon reactivation, users can log in to Ramp again, spend on their previously issued cards and resume receiving Ramp notifications.
PATCH /developer/v1/users/{user_id}/reactivate
Vendor
- Read
List vendors
GET /developer/v1/vendors
GET /developer/v1/vendors - Read
List vendor agreements
POST /developer/v1/vendors/agreements
POST /developer/v1/vendors/agreements - Read
Fetch a vendor agreement
GET /developer/v1/vendors/agreements/{agreement_id}
GET /developer/v1/vendors/agreements/{agreement_id} - Read
List all vendor credits for all vendors of a business
Returns active, visible credits by default. Set isarchived=true to return visible archived credits instead, subject to the remaining filters. Archived credits cannot be applied to bills.
GET /developer/v1/vendors/credits - Read
Fetch a vendor credit
Returns a credit by ID, including archived or hidden credits. A non-null archivedat identifies an archived credit; its remainingamount is retained for reference and cannot be applied to bills.
GET /developer/v1/vendors/credits/{vendor_credit_id} - Read
Fetch a vendor
GET /developer/v1/vendors/{vendor_id}
GET /developer/v1/vendors/{vendor_id} - Read
List vendor bank accounts
GET /developer/v1/vendors/{vendor_id}/accounts
GET /developer/v1/vendors/{vendor_id}/accounts - Read
Fetch a vendor bank account
GET /developer/v1/vendors/{vendor_id}/accounts/{bank_account_id}
GET /developer/v1/vendors/{vendor_id}/accounts/{bank_account_id} - Read
List child vendors of a parent vendor
GET /developer/v1/vendors/{vendor_id}/children
GET /developer/v1/vendors/{vendor_id}/children - Read
List vendor contacts for vendor
GET /developer/v1/vendors/{vendor_id}/contacts
GET /developer/v1/vendors/{vendor_id}/contacts - Read
Fetch a vendor contact
GET /developer/v1/vendors/{vendor_id}/contacts/{vendor_contact_id}
GET /developer/v1/vendors/{vendor_id}/contacts/{vendor_contact_id} - Read
List vendor credits by vendor
Returns active, visible credits by default. Set isarchived=true to return visible archived credits instead. Archived credits cannot be applied to bills.
GET /developer/v1/vendors/{vendor_id}/credits - Read
List available payment methods for a vendor
List available ACH and CHECK payment methods for the specified vendor, with associated fee information.
GET /developer/v1/vendors/{vendor_id}/payment-methods - Write
Create a new vendor
Vendors created through the API are subject to your business's vendor-creation approval policies. Vendors are approved automatically when no approval is required.
POST /developer/v1/vendors - Write
Update a vendor agreement
PATCH /developer/v1/vendors/agreements/{agreement_id}
PATCH /developer/v1/vendors/agreements/{agreement_id} - Write
Upload documents for a vendor agreement
This endpoint accepts the multipart/form-data format. Include each agreement file as a repeated documents part. The request must also include an X-Idempotency-Key header.
POST /developer/v1/vendors/agreements/{agreement_id}/documents - Write
Link purchase orders or documents to a vendor agreement
POST /developer/v1/vendors/agreements/{agreement_id}/link
POST /developer/v1/vendors/agreements/{agreement_id}/link - Write
Link a spend request to a vendor agreement
POST /developer/v1/vendors/agreements/{agreement_id}/link-spend-request
POST /developer/v1/vendors/agreements/{agreement_id}/link-spend-request - Write
Update a vendor
PATCH /developer/v1/vendors/{vendor_id}
PATCH /developer/v1/vendors/{vendor_id} - Write
Create a vendor agreement
POST /developer/v1/vendors/{vendor_id}/agreements
POST /developer/v1/vendors/{vendor_id}/agreements - Write
Create a vendor contact
POST /developer/v1/vendors/{vendor_id}/contacts
POST /developer/v1/vendors/{vendor_id}/contacts - Write
Place a hold on a vendor
Blocks payments to this vendor by placing a vendor-scoped hold. Open, unpaid bills for the vendor that can still be modified are removed from scheduled payment flows. An optional reason can be supplied to record why the hold was placed.
POST /developer/v1/vendors/{vendor_id}/hold - Write
Release Vendor Hold
Releases the active vendor-scoped hold and allows new payments to be scheduled for the vendor. Payments that were removed from scheduled payment flows while the hold was active must be scheduled again after the hold is released.
POST /developer/v1/vendors/{vendor_id}/release - Write
Add to a vendor's bank account details
Adds payment details for the vendor through the approval workflow. The proposal may require approval depending on the business's approval policies.
POST /developer/v1/vendors/{vendor_id}/update-bank-accounts - Destructive
Delete a vendor agreement
DELETE /developer/v1/vendors/agreements/{agreement_id}
DELETE /developer/v1/vendors/agreements/{agreement_id} - Destructive
Unlink purchase orders or documents from a vendor agreement
DELETE /developer/v1/vendors/agreements/{agreement_id}/unlink
DELETE /developer/v1/vendors/agreements/{agreement_id}/unlink - Destructive
Delete a vendor
A vendor cannot be deleted if it has associated transactions, bills, contracts, spend requests, or child vendors.
DELETE /developer/v1/vendors/{vendor_id} - Destructive
Archive a vendor bank account
If the bank account has associated bills, drafts, or recurring templates, a replacementbankaccountid must be provided in the request body.
POST /developer/v1/vendors/{vendor_id}/accounts/{bank_account_id}/archive
Webhooks
- Read
Get all webhook subscriptions
GET /developer/v1/webhooks
GET /developer/v1/webhooks - Read
Get a webhook subscription by id
GET /developer/v1/webhooks/{webhook_id}
GET /developer/v1/webhooks/{webhook_id} - Write
Creates a new webhook subscription
The newly registered subscription will be in the pending verficiation state. You will need to verify your endpoint with the provided challenge.
POST /developer/v1/webhooks - Write
Create a mock webhook event for active subscriptions matching the event type
POST /developer/v1/webhooks/mock-webhook-event
POST /developer/v1/webhooks/mock-webhook-event - Write
Verify a webhook subscription
POST /developer/v1/webhooks/{webhook_id}/verify
POST /developer/v1/webhooks/{webhook_id}/verify - Destructive
Delete a webhook subscription by id
DELETE /developer/v1/webhooks/{webhook_id}
DELETE /developer/v1/webhooks/{webhook_id}
BillingStatement
- Read
List billing statements
List billing statements, optionally filtering by statement period start and end dates. Results use start/page_size pagination (2–100 per page, default 20).
GET /developer/v1/billing/statements
Payment
- Read
List payments
List payments, filtering by external reference, status or vendor. Canceled payments are excluded by default unless requested; results are paginated.
GET /developer/v1/payments - Read
Preview how an address and memo are truncated when printed on a check
Preview how a payment address and memo will be truncated when printed on a check. This POST is a preview/read operation; Type still requires full request access for POST.
POST /developer/v1/payments/check-preview - Read
Fetch a payment
Fetch the identified payment and its current details.
GET /developer/v1/payments/{payment_id} - Read
Fetch a payment remittance receipt
Fetch the identified payment’s remittance receipt as a PDF response.
GET /developer/v1/payments/{payment_id}/remittance-receipt - Write
Update a payment
Update the identified payment using the documented payment update fields.
PATCH /developer/v1/payments/{payment_id} - Destructive
Create and initiate a payment
Create and initiate a payment. Requires a client-generated X-Idempotency-Key header; this action can move funds.
POST /developer/v1/payments - Destructive
Cancel a payment
Cancel the identified payment. A successful cancellation returns HTTP 204.
DELETE /developer/v1/payments/{payment_id} - Destructive
Retry a failed payment
Retry a failed payment. Requires a client-generated X-Idempotency-Key header and can initiate funds movement again.
POST /developer/v1/payments/{payment_id}/retry
Card Vault
- Read
Fetch a card's sensitive details (deprecated)
Fetch sensitive details for the specified card ID. This deprecated endpoint requires separately approved Vault API access.
GET /developer/v1/vault/cards/{card_id} - Write
Create a spend limit and retrieve sensitive card details (deprecated)
Create a spend limit and retrieve sensitive card details. This deprecated endpoint requires Vault API access and both cards:read_vault and limits:write scopes.
POST /developer/v1/vault/cards
No operations match.
Get started
- Open Space settings → Connections and search for Ramp.
- Connect your account and add the connection to the Space.
- Ask for what you need in any thread in that Space.
See How connections work for access and permissions, or browse all integrations.